import es
import gamethread
import time

info = es.AddonInfo()
info.version = "1.0"
info.author = ""
info.name = "endround"
info.url = ""
info.date = ""
info.sponsor = ""

er_realround = es.ServerVar('er_realround', 0, 'Boolean value telling whether a round is active')
isenabled = es.ServerVar('er_endround', 1, 'Is %s enabled'%info.name)
er_endround_effect = es.ServerVar('er_endround_effect', 1, 'Play sound and display message or not?')
disable_on_maps = es.ServerVar('er_disabled_maps', '', "Disable %s on specified maps, multiple names must be separated with commas (,); names are considered to be either full or partial map names"%info.name)

mapname = es.ServerVar('eventscripts_currentmap')
# end of server variable stuff...

mp_roundtime = es.ServerVar('mp_roundtime')
roundtime = float(mp_roundtime)*60.0
last_er_roundtime = 0

laststart = time.time()

ROUND_DRAW_SOUND = 'radio/rounddraw.wav'

def _ticker():
    now = time.time()
    if now-laststart >= roundtime:
        round_draw()

def _start_ticking():
    global isticking
    if not isticking:
        es.addons.registerTickListener(_ticker)
        isticking = True

def _stop_ticking():
    global isticking
    if isticking:
        es.addons.unregisterTickListener(_ticker)
        isticking = False
    
isticking = False
    
def load():
    if not es.exists('command', 'er_roundtime'):
        es.regcmd('er_roundtime', 'sici_jail/modules/endround/er_roundtime', 'Overrides mp_roundtime for')
    es.flags('remove', 'cheat', 'endround')
    es.dbgmsg(0, '[Sici Jail] Modules : Endround On')
    

def unload():
    if isticking:
        es.addons.unregisterTickListener(_ticker)
    es.dbgmsg(0, '[Sici Jail] Modules : Endround Off')
        

def er_roundtime():
    global roundtime, last_er_roundtime
    argc = es.getargc()
    if argc == 1:
        mins, secs = divmod(last_er_roundtime, 60)
        es.dbgmsg(0, '"er_roundtime" = "%d:%02d" min. %0.6f'%(
            mins, secs, 0.0,
            )
                  )
        es.dbgmsg(0, ' - If nonzero, overrides mp_roundtime for the value %s uses for round length'%(
            info.name)
                  )
        es.dbgmsg(0, ' - Can be either integer, floating point number or string of form "min:sec"')
        mins, secs = divmod(roundtime, 60)
        es.dbgmsg(0, ' - Currently effective roundtime = %d:%02d'%(
            mins, secs,
            )
                  )
        return
    elif argc == 2:
        timearg = es.getargv(1)
        try:
            mins = float(timearg)
            secs = 0.0
        except ValueError:
            try:
                mins, secs = (float(x) for x in timearg.split(':', 1))
            except ValueError:
                es.dbgmsg(0, 'Invalid value %s for er_roundtime'%timearg)
                return
    elif argc == 4:
        if es.getargv(2) == ':':
            try:
                mins = float(es.getargv(1))
                secs = float(es.getargv(3))
            except ValueError:
                es.dbgmsg(0, 'Invalid value %s for er_roundtime'%es.getargs())
                return
    else:
        es.dbgmsg(0, 'Invalid value %s for er_roundtime'%es.getargs())
        return
    
    secs = int(secs + mins*60)
    if secs <= 0:
        secs = 0
        roundtime = float(mp_roundtime)*60.0
    else:
        roundtime = float(secs)
    
    last_er_roundtime = secs

def round_draw():
    _stop_ticking()
    # Check for maps exclusions
    curmap = str(mapname)
    for mapmatch in str(disable_on_maps).split(','):
        if mapmatch and mapmatch in curmap:
            # disabled on this map
            es.dbgmsg(1, '%s: Map name "%s" matched disable filter "%s", not forcing round draw.'%(
                info.name, curmap, mapmatch,
                )
                      )
            return
    
    if int(isenabled):
        er_realround.set(0)
        if int(er_endround_effect):
            for userid in es.getUseridList():
                es.playsound(userid, ROUND_DRAW_SOUND, 1.0)
                # the following only works in CS:S, but who cares, it is just extra
                es.setplayerprop(userid, 'CCSPlayer.m_iPlayerState', 1)
            es.centermsg('Round Draw!')
            gamethread.delayed(2, invoke_round_draw)
        else:
            invoke_round_draw()
    else:
        es.dbgmsg(1, '%s: CVAR er_endround is set to 0, not forcing round draw.'%(
            info.name,
            )
                  )
        

def invoke_round_draw():
    es.ServerCommand('endround')
    

def round_start(ev):
    global laststart, roundtime
    laststart = time.time()
    _start_ticking()
    if last_er_roundtime == 0:
        roundtime = float(mp_roundtime)*60.0

def round_freeze_end(ev):
    round_start(ev)
    er_realround.set(1)

def game_start(ev):
    round_start(ev)


# ROUND_END
def round_end(ev):
    er_realround.set(0)
    _stop_ticking()

def game_end(ev):
    round_end(ev)


